#pragma once

enum {
	evt_FIRST_EVENT		= 1310,
	
	evt_PlayStarted,
	evt_PlayStopped,
	evt_PlayToggle,
	evt_TrackDone,
	evt_AddItem,							// add item to playlist, ioData = FSSpecPtr
	evt_AddRawItem,							// add item to playlist, ioData = STableItem*
	evt_NextTrack,
	evt_PrevTrack,
	
	evt_SavePlaylist,
	evt_LoadPlaylist,
	evt_ClearPlaylist,
	evt_ClearSong,
	evt_RememberPlaylist,					// auto-save on quit only
	evt_ProcessKeyDown,						// ioData = char code
	
	evt_SortPlaylistByName,
	evt_SortPlaylistByTime,	
	evt_SortPlaylistByType,
	
	evt_SaveContext,						// save objects context before skin change			
	evt_RestoreContext,						// restore objects context after skin change
	
	evt_Minimize,
	evt_Maximize,
	
	evt_PlaylistCollapse,
	evt_PlaylistExpand,

	evt_GetTrackInfo,
	evt_RefreshItem,

	evt_ID3,								// ioData = ID3InfoPtr
	
	evt_Suspend,							// suspend app services on EnterFullScreen() VP hook
	evt_Resume,								// resume app services on EnterFullScreen() VP hook
	
	// This are custom event your plugins may use to communicate with each other.
	evt_Custom,								// ioData = CustomEventPtr!!
	
	evt_LAST_EVENT
};

typedef struct
{
	Str255	title;
	Str255	author;
	Str255	album;
	Str255	genre;
	Str32	year;
	Ptr		lyrics;
} ID3Info, *ID3InfoPtr;

typedef struct
{
	OSType	family;		// custom event family id. may as well be your plugin author id
	OSType	id;			// custom event id
	Ptr		data;		// ptr pointing to event data
} CustomEventRec, *CustomEventRecPtr;